<template>
  <div>
    <md-dialog :md-active.sync="$store.state.showDialog">
      <md-dialog-title>Post creator</md-dialog-title>
      <div class="md-layout md-gutter md-alignment-center">
        <md-card class="md-layout-item md-medium-size-33 md-small-size-50 md-xsmall-size-100">
          <form action="/" enctype="multipart/form-data">
            <md-card-content>
              <md-field>
                <label>Add short description...</label>
                <md-textarea v-model="formData.text" md-counter="400" required></md-textarea>
                <span class="md-error">There is an error</span>
              </md-field>
              <md-field
                :class="{
                  'md-invalid': $v.file.invalidFileType && $v.file.$dirty
                }"
              >
                <label>Add image</label>
                <md-file name="file" @change="convertImageToString" />
                <div class="md-error-container">
                  <span class="md-error">Accept only: jpeg, jpg, png and gif file type.</span>
                </div>
              </md-field>
              <div class="progress-bar-container">
                <md-progress-bar
                  v-if="disabledBtn"
                  class="md-accent"
                  md-mode="determinate"
                  :md-value="progressBar"
                ></md-progress-bar>
              </div>
            </md-card-content>
            <md-dialog-actions>
              <md-button
                class="md-primary"
                :disabled="disabledBtn"
                @click="toggleShowModal('addPost')"
              >Cancel</md-button>
              <div class="publish-button-container">
                <md-button
                  class="md-raised md-primary"
                  :disabled="disabledBtn"
                  @click.prevent="createPostTool"
                >Publish</md-button>
                <md-progress-spinner
                  class="md-accent"
                  v-if="progressBar === 100 && disabledBtn"
                  :md-diameter="20"
                  :md-stroke="3"
                  md-mode="indeterminate"
                ></md-progress-spinner>
              </div>
            </md-dialog-actions>
          </form>
        </md-card>
      </div>
    </md-dialog>
  </div>
</template>

<script>
import { mapMutations, mapActions, mapState } from "vuex";
import { convertToBase64 } from "@/mixins/mixins";

const invalidFileType = value => {
  try {
    return !["image/jpg", "image/jpeg", "image/png", "image/gif"].includes(
      value.type
    );
  } catch {
    console.log("Can't get file type!");
  }
};

export default {
  name: "DialogCustom",
  props: ["user"],
  mixins: [convertToBase64],

  data() {
    return {
      file: "",
      showHideModal: false,
      formData: {
        text: "",
        image: "",
        likes: []
      },
      disabledBtn: false
    };
  },
  validations: {
    file: {
      invalidFileType
    }
  },
  computed: {
    ...mapState(["progressBar"])
  },
  methods: {
    ...mapMutations(["toggleShowModal", "clearProgressBar"]),
    ...mapActions(["createPost"]),

    changeDisabledState() {
      this.disabledBtn = !this.disabledBtn;
    },

    setInitalValues() {
      this.formData.text = "";
      this.formData.image = "";
      this.formData.likes = [];
    },

    async convertImageToString(event) {
      this.file = event.target.files[0];
      try {
        const base64String = await this.convertToBase64(event);
        this.formData.image = base64String;
      } catch (error) {
        console.log("Error: ", error);
      }
    },

    createPostTool() {
      this.$v.$touch();
      if (!this.$v.file.invalidFileType) {
        this.changeDisabledState();
        this.createPost({
          formData: this.formData,
          user: this.user
        }).then(() => {
          this.clearProgressBar();
          this.changeDisabledState();
          this.setInitalValues();
        });
      }
    }
  }
};
</script>

<style lang="scss" scoped>
.md-dialog {
  width: 500px;
}
.md-invalid {
  display: flex;
  flex-direction: column;
  .md-error-container {
    width: 100%;
    position: relative;
    margin-left: 36px;
  }
}
#input-file-addon {
  display: none;
  opacity: 0;
}
.publish-button-container {
  margin-left: 10px;
  position: relative;
  display: flex;
  align-items: center;
  justify-content: center;
  .md-progress-spinner {
    position: absolute;
    z-index: 5;
  }
}
.progress-bar-container {
  height: 5px;
  width: 100%;
}
</style>
